summaryrefslogtreecommitdiff
path: root/scripts/git-submodule.sh
diff options
context:
space:
mode:
authorDaniel P. Berrange <berrange@redhat.com>2017-10-27 10:49:58 +0100
committerDaniel P. Berrange <berrange@redhat.com>2017-11-06 11:05:12 +0000
commit37b5e74e28f4b3ee93c28eb0106a65e02521f48b (patch)
tree4c6c571cff454e8a03c2581b77467e6191f6c3b4 /scripts/git-submodule.sh
parentf62bbee55d503f639ee9498878ebf42ff4f4299a (diff)
downloadqemu-37b5e74e28f4b3ee93c28eb0106a65e02521f48b.tar.gz
build: don't fail if given a git submodule which does not exist
If going back in time in git history, across a commit that introduces a new submodule, the 'git-submodule.sh' script will fail, causing rebuild to fail. This is because config-host.mak contains a GIT_SUBMODULES variable that lists a submodule that only exists in the later commit. config-host.mak won't get repopulated until config.status is invoked, but make won't get this far due to the submodule error. This change makes 'git-submodule.sh' check whether each module is known to git and drops any which are not present. A warning message will be printed when any submodule is dropped in this manner. Tested-by: Philippe Mathieu-Daudé <f4bug@amsat.org> Reviewed-by: Eric Blake <eblake@redhat.com> Signed-off-by: Daniel P. Berrange <berrange@redhat.com>
Diffstat (limited to 'scripts/git-submodule.sh')
-rwxr-xr-xscripts/git-submodule.sh16
1 files changed, 14 insertions, 2 deletions
diff --git a/scripts/git-submodule.sh b/scripts/git-submodule.sh
index 63ace6fc55..3683bc9a04 100755
--- a/scripts/git-submodule.sh
+++ b/scripts/git-submodule.sh
@@ -7,7 +7,7 @@ substat=".git-submodule-status"
command=$1
shift
-modules="$@"
+maybe_modules="$@"
test -z "$GIT" && GIT=git
@@ -33,12 +33,24 @@ error() {
exit 1
}
-if test -z "$modules"
+if test -z "$maybe_modules"
then
test -e $substat || touch $substat
exit 0
fi
+modules=""
+for m in $maybe_modules
+do
+ $GIT submodule status $m 1> /dev/null 2>&1
+ if test $? = 0
+ then
+ modules="$modules $m"
+ else
+ echo "warn: ignoring non-existent submodule $m"
+ fi
+done
+
if ! test -e ".git"
then
echo "$0: unexpectedly called with submodules but no git checkout exists"